package dev.shadowsoffire.apotheosis.ench;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.google.common.collect.ImmutableSet;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.ench.Ench;
import dev.shadowsoffire.apotheosis.ench.EnchConfig;
import dev.shadowsoffire.apotheosis.ench.EnchModuleClient;
import dev.shadowsoffire.apotheosis.ench.EnchModuleEvents;
import dev.shadowsoffire.apotheosis.ench.EnchantmentInfo;
import dev.shadowsoffire.apotheosis.ench.anvil.ApothAnvilBlock;
import dev.shadowsoffire.apotheosis.ench.anvil.ApothAnvilItem;
import dev.shadowsoffire.apotheosis.ench.asm.EnchHooks;
import dev.shadowsoffire.apotheosis.ench.compat.EnchTOPPlugin;
import dev.shadowsoffire.apotheosis.ench.objects.TomeItem;
import dev.shadowsoffire.apotheosis.ench.objects.TypedShelfBlock;
import dev.shadowsoffire.apotheosis.ench.objects.WardenLootModifier;
import dev.shadowsoffire.apotheosis.ench.replacements.BaneEnchant;
import dev.shadowsoffire.apotheosis.ench.replacements.DefenseEnchant;
import dev.shadowsoffire.apotheosis.ench.table.ApothEnchantBlock;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingRecipe;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import dev.shadowsoffire.apotheosis.ench.table.KeepNBTEnchantingRecipe;
import dev.shadowsoffire.placebo.config.Configuration;
import dev.shadowsoffire.placebo.loot.LootSystem;
import dev.shadowsoffire.placebo.menu.MenuUtil;
import dev.shadowsoffire.placebo.recipe.RecipeHelper;
import dev.shadowsoffire.placebo.registry.RegistryEvent;
import dev.shadowsoffire.placebo.tabs.ITabFiller;
import dev.shadowsoffire.placebo.tabs.TabFillingRegistry;
import dev.shadowsoffire.placebo.util.PlaceboUtil;
import it.unimi.dsi.fastutil.objects.Object2IntMap;
import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.function.Function;
import java.util.function.Supplier;
import net.minecraft.core.dispenser.DispenseItemBehavior;
import net.minecraft.core.dispenser.ShearsDispenseItemBehavior;
import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.core.particles.ParticleType;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.core.particles.SimpleParticleType;
import net.minecraft.network.chat.TextColor;
import net.minecraft.resources.ResourceKey;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.MobType;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.item.BlockItem;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.EnchantedBookItem;
import net.minecraft.world.item.HoeItem;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.ShearsItem;
import net.minecraft.world.item.ShieldItem;
import net.minecraft.world.item.alchemy.Potions;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentCategory;
import net.minecraft.world.item.enchantment.EnchantmentInstance;
import net.minecraft.world.item.enchantment.ProtectionEnchantment;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.DispenserBlock;
import net.minecraft.world.level.block.SoundType;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.material.MapColor;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.common.ToolActions;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.InterModComms;
import net.minecraftforge.fml.ModList;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.event.lifecycle.InterModProcessEvent;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.loading.FMLEnvironment;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.RegisterEvent;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class EnchModule {
  public static final Map<Enchantment, EnchantmentInfo> ENCHANTMENT_INFO = new HashMap<>();
  
  public static final Object2IntMap<Enchantment> ENCH_HARD_CAPS = (Object2IntMap<Enchantment>)new Object2IntOpenHashMap();
  
  public static final String ENCH_HARD_CAP_IMC = "set_ench_hard_cap";
  
  public static final Logger LOGGER = LogManager.getLogger("Apotheosis : Enchantment");
  
  public static final List<TomeItem> TYPED_BOOKS = new ArrayList<>();
  
  public static final EquipmentSlot[] ARMOR = new EquipmentSlot[] { EquipmentSlot.HEAD, EquipmentSlot.CHEST, EquipmentSlot.LEGS, EquipmentSlot.FEET };
  
  public static final EnchantmentCategory HOE = EnchantmentCategory.create("HOE", HoeItem.class::isInstance);
  
  static {
    Objects.requireNonNull(HoeItem.class);
  }
  
  public static final EnchantmentCategory SHIELD = EnchantmentCategory.create("SHIELD", ShieldItem.class::isInstance);
  
  public static final EnchantmentCategory ANVIL;
  
  static {
    Objects.requireNonNull(ShieldItem.class);
  }
  
  static {
    ANVIL = EnchantmentCategory.create("ANVIL", i -> (i instanceof BlockItem && ((BlockItem)i).m_40614_() instanceof net.minecraft.world.level.block.AnvilBlock));
    Objects.requireNonNull(ShearsItem.class);
  }
  
  public static final EnchantmentCategory SHEARS = EnchantmentCategory.create("SHEARS", ShearsItem.class::isInstance);
  
  public static final EnchantmentCategory PICKAXE;
  
  public static final EnchantmentCategory AXE;
  
  public static final EnchantmentCategory CORE_ARMOR;
  
  static Configuration enchInfoConfig;
  
  static {
    PICKAXE = EnchantmentCategory.create("PICKAXE", i -> i.canPerformAction(new ItemStack((ItemLike)i), ToolActions.PICKAXE_DIG));
    AXE = EnchantmentCategory.create("AXE", i -> i.canPerformAction(new ItemStack((ItemLike)i), ToolActions.AXE_DIG));
    CORE_ARMOR = EnchantmentCategory.create("CORE_ARMOR", i -> (EnchantmentCategory.ARMOR_CHEST.m_7454_(i) || EnchantmentCategory.ARMOR_LEGS.m_7454_(i)));
  }
  
  public EnchModule() {
    if (FMLEnvironment.dist.isClient())
      FMLJavaModLoadingContext.get().getModEventBus().register(EnchModuleClient.class); 
    Ench.bootstrap();
  }
  
  @SubscribeEvent
  public void init(FMLCommonSetupEvent e) {
    reload(null);
    Apotheosis.HELPER.registerProvider(factory -> {
          Ingredient pot = Apotheosis.potionIngredient(Potions.f_43587_);
          factory.addShaped(Ench.Blocks.HELLSHELF.get(), 3, 3, new Object[] { Blocks.f_50197_, Blocks.f_50197_, Blocks.f_50197_, Items.f_42585_, "forge:bookshelves", pot, Blocks.f_50197_, Blocks.f_50197_, Blocks.f_50197_ });
          factory.addShaped(Ench.Items.PRISMATIC_WEB, 3, 3, new Object[] { null, Items.f_42695_, null, Items.f_42695_, Blocks.f_50033_, Items.f_42695_, null, Items.f_42695_, null });
          ItemStack book = new ItemStack((ItemLike)Items.f_42517_);
          ItemStack stick = new ItemStack((ItemLike)Items.f_42398_);
          ItemStack blaze = new ItemStack((ItemLike)Items.f_42585_);
          factory.addShaped(new ItemStack((ItemLike)Ench.Items.HELMET_TOME.get(), 5), 3, 2, new Object[] { book, book, book, book, blaze, book });
          factory.addShaped(new ItemStack((ItemLike)Ench.Items.CHESTPLATE_TOME.get(), 8), 3, 3, new Object[] { book, blaze, book, book, book, book, book, book, book });
          factory.addShaped(new ItemStack((ItemLike)Ench.Items.LEGGINGS_TOME.get(), 7), 3, 3, new Object[] { book, null, book, book, blaze, book, book, book, book });
          factory.addShaped(new ItemStack((ItemLike)Ench.Items.BOOTS_TOME.get(), 4), 3, 2, new Object[] { book, null, book, book, blaze, book });
          factory.addShaped(new ItemStack((ItemLike)Ench.Items.WEAPON_TOME.get(), 2), 1, 3, new Object[] { book, book, new ItemStack((ItemLike)Items.f_42593_) });
          factory.addShaped(new ItemStack((ItemLike)Ench.Items.PICKAXE_TOME.get(), 3), 3, 3, new Object[] { book, book, book, null, blaze, null, null, stick, null });
          factory.addShaped(new ItemStack((ItemLike)Ench.Items.FISHING_TOME.get(), 2), 3, 3, new Object[] { null, null, blaze, null, stick, book, stick, null, book });
          factory.addShaped(new ItemStack((ItemLike)Ench.Items.BOW_TOME.get(), 3), 3, 3, new Object[] { null, stick, book, blaze, null, book, null, stick, book });
          factory.addShapeless(new ItemStack((ItemLike)Ench.Items.OTHER_TOME.get(), 6), new Object[] { book, book, book, book, book, book, blaze });
          factory.addShaped(new ItemStack((ItemLike)Ench.Items.SCRAP_TOME.get(), 8), 3, 3, new Object[] { book, book, book, book, Blocks.f_50322_, book, book, book, book });
          Ingredient maxHellshelf = Ingredient.m_43929_(new ItemLike[] { (ItemLike)Ench.Blocks.INFUSED_HELLSHELF.get() });
          factory.addShaped(Ench.Blocks.BLAZING_HELLSHELF.get(), 3, 3, new Object[] { null, Items.f_42613_, null, Items.f_42613_, maxHellshelf, Items.f_42613_, Items.f_42593_, Items.f_42593_, Items.f_42593_ });
          factory.addShaped(Ench.Blocks.GLOWING_HELLSHELF.get(), 3, 3, new Object[] { null, Blocks.f_50141_, null, null, maxHellshelf, null, Blocks.f_50141_, null, Blocks.f_50141_ });
          factory.addShaped(Ench.Blocks.SEASHELF.get(), 3, 3, new Object[] { Blocks.f_50378_, Blocks.f_50378_, Blocks.f_50378_, Apotheosis.potionIngredient(Potions.f_43599_), "forge:bookshelves", Items.f_42529_, Blocks.f_50378_, Blocks.f_50378_, Blocks.f_50378_ });
          Ingredient maxSeashelf = Ingredient.m_43929_(new ItemLike[] { (ItemLike)Ench.Blocks.INFUSED_SEASHELF.get() });
          factory.addShaped(Ench.Blocks.CRYSTAL_SEASHELF.get(), 3, 3, new Object[] { null, Items.f_42696_, null, null, maxSeashelf, null, Items.f_42696_, null, Items.f_42696_ });
          factory.addShaped(Ench.Blocks.HEART_SEASHELF.get(), 3, 3, new Object[] { null, Items.f_42716_, null, Items.f_42695_, maxSeashelf, Items.f_42695_, Items.f_42695_, Items.f_42695_, Items.f_42695_ });
          factory.addShaped(Ench.Blocks.PEARL_ENDSHELF.get(), 3, 3, new Object[] { Items.f_42001_, null, Items.f_42001_, "forge:ender_pearls", Ench.Blocks.ENDSHELF.get(), "forge:ender_pearls", Items.f_42001_, null, Items.f_42001_ });
          factory.addShaped(Ench.Blocks.DRACONIC_ENDSHELF.get(), 3, 3, new Object[] { null, Items.f_42683_, null, "forge:ender_pearls", Ench.Blocks.ENDSHELF.get(), "forge:ender_pearls", "forge:ender_pearls", "forge:ender_pearls", "forge:ender_pearls" });
          factory.addShaped(Ench.Blocks.BEESHELF.get(), 3, 3, new Object[] { Items.f_42784_, Items.f_42786_, Items.f_42784_, Items.f_42788_, "forge:bookshelves", Items.f_42788_, Items.f_42784_, Items.f_42786_, Items.f_42784_ });
          factory.addShaped(Ench.Blocks.MELONSHELF.get(), 3, 3, new Object[] { Items.f_42028_, Items.f_42028_, Items.f_42028_, Items.f_42546_, "forge:bookshelves", Items.f_42546_, Items.f_42028_, Items.f_42028_, Items.f_42028_ });
        });
    MinecraftForge.EVENT_BUS.register(new EnchModuleEvents());
    MinecraftForge.EVENT_BUS.addListener(this::reload);
    e.enqueueWork(() -> {
          LootSystem.defaultBlockTable((Block)Ench.Blocks.HELLSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.INFUSED_HELLSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.BLAZING_HELLSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.GLOWING_HELLSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.SEASHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.INFUSED_SEASHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.CRYSTAL_SEASHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.HEART_SEASHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.DORMANT_DEEPSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.DEEPSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.ECHOING_DEEPSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.SOUL_TOUCHED_DEEPSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.ECHOING_SCULKSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.SOUL_TOUCHED_SCULKSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.ENDSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.PEARL_ENDSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.DRACONIC_ENDSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.BEESHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.MELONSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.STONESHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.LIBRARY.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.RECTIFIER.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.RECTIFIER_T2.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.RECTIFIER_T3.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.SIGHTSHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.SIGHTSHELF_T2.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.ENDER_LIBRARY.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.FILTERING_SHELF.get());
          LootSystem.defaultBlockTable((Block)Ench.Blocks.TREASURE_SHELF.get());
          DispenserBlock.m_52672_((ItemLike)Items.f_42574_, (DispenseItemBehavior)new ShearsDispenseItemBehavior());
          TabFillingRegistry.register(Ench.Tabs.ENCH.getKey(), new Supplier[] { 
                (Supplier)Ench.Items.HELLSHELF, (Supplier)Ench.Items.INFUSED_HELLSHELF, (Supplier)Ench.Items.BLAZING_HELLSHELF, (Supplier)Ench.Items.GLOWING_HELLSHELF, (Supplier)Ench.Items.SEASHELF, (Supplier)Ench.Items.INFUSED_SEASHELF, (Supplier)Ench.Items.CRYSTAL_SEASHELF, (Supplier)Ench.Items.HEART_SEASHELF, (Supplier)Ench.Items.DORMANT_DEEPSHELF, (Supplier)Ench.Items.DEEPSHELF, 
                (Supplier)Ench.Items.ECHOING_DEEPSHELF, (Supplier)Ench.Items.SOUL_TOUCHED_DEEPSHELF, (Supplier)Ench.Items.ECHOING_SCULKSHELF, (Supplier)Ench.Items.SOUL_TOUCHED_SCULKSHELF, (Supplier)Ench.Items.ENDSHELF, (Supplier)Ench.Items.PEARL_ENDSHELF, (Supplier)Ench.Items.DRACONIC_ENDSHELF, (Supplier)Ench.Items.BEESHELF, (Supplier)Ench.Items.MELONSHELF, (Supplier)Ench.Items.STONESHELF, 
                (Supplier)Ench.Items.RECTIFIER, (Supplier)Ench.Items.RECTIFIER_T2, (Supplier)Ench.Items.RECTIFIER_T3, (Supplier)Ench.Items.SIGHTSHELF, (Supplier)Ench.Items.SIGHTSHELF_T2, (Supplier)Ench.Items.FILTERING_SHELF, (Supplier)Ench.Items.TREASURE_SHELF, (Supplier)Ench.Items.LIBRARY, (Supplier)Ench.Items.ENDER_LIBRARY });
          TabFillingRegistry.register(Ench.Tabs.ENCH.getKey(), new Supplier[] { 
                (Supplier)Ench.Items.HELMET_TOME, (Supplier)Ench.Items.CHESTPLATE_TOME, (Supplier)Ench.Items.LEGGINGS_TOME, (Supplier)Ench.Items.BOOTS_TOME, (Supplier)Ench.Items.WEAPON_TOME, (Supplier)Ench.Items.BOW_TOME, (Supplier)Ench.Items.PICKAXE_TOME, (Supplier)Ench.Items.FISHING_TOME, (Supplier)Ench.Items.OTHER_TOME, (Supplier)Ench.Items.SCRAP_TOME, 
                (Supplier)Ench.Items.IMPROVED_SCRAP_TOME, (Supplier)Ench.Items.EXTRACTION_TOME });
          TabFillingRegistry.register(Ench.Tabs.ENCH.getKey(), new Supplier[] { (Supplier)Ench.Items.PRISMATIC_WEB, (Supplier)Ench.Items.INERT_TRIDENT, (Supplier)Ench.Items.WARDEN_TENDRIL, (Supplier)Ench.Items.INFUSED_BREATH });
          fill(Ench.Tabs.ENCH.getKey(), (Supplier<? extends Enchantment>[])new Supplier[] { 
                (Supplier)Ench.Enchantments.BERSERKERS_FURY, (Supplier)Ench.Enchantments.CHAINSAW, (Supplier)Ench.Enchantments.CHROMATIC, (Supplier)Ench.Enchantments.CRESCENDO, (Supplier)Ench.Enchantments.EARTHS_BOON, (Supplier)Ench.Enchantments.ENDLESS_QUIVER, (Supplier)Ench.Enchantments.EXPLOITATION, (Supplier)Ench.Enchantments.GROWTH_SERUM, (Supplier)Ench.Enchantments.ICY_THORNS, (Supplier)Ench.Enchantments.KNOWLEDGE, 
                (Supplier)Ench.Enchantments.LIFE_MENDING, (Supplier)Ench.Enchantments.MINERS_FERVOR, (Supplier)Ench.Enchantments.NATURES_BLESSING, (Supplier)Ench.Enchantments.OBLITERATION, (Supplier)Ench.Enchantments.REBOUNDING, (Supplier)Ench.Enchantments.REFLECTIVE, (Supplier)Ench.Enchantments.SCAVENGER, (Supplier)Ench.Enchantments.SHIELD_BASH, (Supplier)Ench.Enchantments.SPEARFISHING, (Supplier)Ench.Enchantments.SPLITTING, 
                (Supplier)Ench.Enchantments.STABLE_FOOTING, (Supplier)Ench.Enchantments.TEMPTING });
          PlaceboUtil.registerCustomColor((TextColor)Ench.Colors.LIGHT_BLUE_FLASH);
        });
    if (ModList.get().isLoaded("theoneprobe"))
      EnchTOPPlugin.register(); 
    EnchantingStatRegistry.INSTANCE.registerToBus();
  }
  
  @SubscribeEvent
  public void client(FMLClientSetupEvent e) {
    MinecraftForge.EVENT_BUS.register(new EnchModuleClient());
    e.enqueueWork(EnchModuleClient::init);
  }
  
  @SubscribeEvent
  public void miscRegistration(RegisterEvent e) {
    if (e.getForgeRegistry() == ForgeRegistries.GLOBAL_LOOT_MODIFIER_SERIALIZERS.get())
      e.getForgeRegistry().register("warden_tendril", WardenLootModifier.CODEC); 
  }
  
  @SubscribeEvent
  public void tiles(RegistryEvent.Register<BlockEntityType<?>> e) {
    e.getRegistry().register(new BlockEntityType(dev.shadowsoffire.apotheosis.ench.anvil.AnvilTile::new, ImmutableSet.of(Blocks.f_50322_, Blocks.f_50323_, Blocks.f_50324_), null), "anvil");
    BlockEntityType.f_58928_.f_58914_ = dev.shadowsoffire.apotheosis.ench.table.ApothEnchantTile::new;
    BlockEntityType.f_58928_.f_58915_ = ImmutableSet.of(Blocks.f_50201_);
    e.getRegistry().register(new BlockEntityType(dev.shadowsoffire.apotheosis.ench.library.EnchLibraryTile.BasicLibraryTile::new, ImmutableSet.of((Block)Ench.Blocks.LIBRARY.get()), null), "library");
    e.getRegistry().register(new BlockEntityType(dev.shadowsoffire.apotheosis.ench.library.EnchLibraryTile.EnderLibraryTile::new, ImmutableSet.of((Block)Ench.Blocks.ENDER_LIBRARY.get()), null), "ender_library");
  }
  
  @SubscribeEvent
  public void containers(RegistryEvent.Register<MenuType<?>> e) {
    e.getRegistry().register(MenuUtil.type(dev.shadowsoffire.apotheosis.ench.table.ApothEnchantmentMenu::new), "enchanting_table");
    e.getRegistry().register(MenuUtil.posType(dev.shadowsoffire.apotheosis.ench.library.EnchLibraryContainer::new), "library");
  }
  
  @SubscribeEvent
  public void recipeSerializers(RegistryEvent.Register<RecipeSerializer<?>> e) {
    e.getRegistry().register(EnchantingRecipe.SERIALIZER, "enchanting");
    e.getRegistry().register(KeepNBTEnchantingRecipe.SERIALIZER, "keep_nbt_enchanting");
  }
  
  @SubscribeEvent
  public void particles(RegistryEvent.Register<ParticleType<?>> e) {
    e.getRegistry().registerAll(new Object[] { new SimpleParticleType(false), "enchant_fire", new SimpleParticleType(false), "enchant_water", new SimpleParticleType(false), "enchant_sculk", new SimpleParticleType(false), "enchant_end" });
  }
  
  @SubscribeEvent
  public void handleIMC(InterModProcessEvent e) {
    e.getIMCStream("set_ench_hard_cap"::equals).forEach(msg -> {
          try {
            EnchantmentInstance data = msg.messageSupplier().get();
            if (data != null && data.f_44947_ != null && data.f_44948_ > 0) {
              ENCH_HARD_CAPS.put(data.f_44947_, data.f_44948_);
            } else {
              LOGGER.error("Failed to process IMC message with method {} from {} (invalid values passed).", msg.method(), msg.senderModId());
            } 
          } catch (Exception ex) {
            LOGGER.error("Exception thrown during IMC message with method {} from {}.", msg.method(), msg.senderModId());
            ex.printStackTrace();
          } 
        });
  }
  
  @SubscribeEvent
  public void blocks(RegistryEvent.Register<Block> e) {
    e.getRegistry().registerAll(new Object[] { new ApothAnvilBlock(), new ResourceLocation("minecraft", "anvil"), new ApothAnvilBlock(), new ResourceLocation("minecraft", "chipped_anvil"), new ApothAnvilBlock(), new ResourceLocation("minecraft", "damaged_anvil") });
    PlaceboUtil.registerOverride(Blocks.f_50201_, (Block)new ApothEnchantBlock(), "apotheosis");
  }
  
  private static Block shelf(BlockBehaviour.Properties props, float strength) {
    return shelf(props, strength, () -> ParticleTypes.f_123809_);
  }
  
  private static Block shelf(BlockBehaviour.Properties props, float strength, Supplier<? extends ParticleOptions> particle) {
    props.m_60978_(strength);
    return (Block)new TypedShelfBlock(props, particle);
  }
  
  private static Block sculkShelf(float strength, Supplier<? extends ParticleOptions> particle) {
    BlockBehaviour.Properties props = BlockBehaviour.Properties.m_284310_().m_284180_(MapColor.f_283927_).m_60918_(SoundType.f_56742_).m_60978_(strength).m_60977_().m_60999_();
    return (Block)new TypedShelfBlock.SculkShelfBlock(props, particle);
  }
  
  @SubscribeEvent
  public void items(RegistryEvent.Register<Item> e) {
    e.getRegistry().registerAll(new Object[] { new ApothAnvilItem(Blocks.f_50322_), new ResourceLocation("minecraft", "anvil"), new ApothAnvilItem(Blocks.f_50323_), new ResourceLocation("minecraft", "chipped_anvil"), new ApothAnvilItem(Blocks.f_50324_), new ResourceLocation("minecraft", "damaged_anvil") });
  }
  
  @SubscribeEvent
  public void enchants(RegistryEvent.Register<Enchantment> e) {
    e.getRegistry().registerAll(new Object[] { 
          new BaneEnchant(Enchantment.Rarity.UNCOMMON, MobType.f_21642_, new EquipmentSlot[] { EquipmentSlot.MAINHAND }), new ResourceLocation("minecraft", "bane_of_arthropods"), new BaneEnchant(Enchantment.Rarity.UNCOMMON, MobType.f_21641_, new EquipmentSlot[] { EquipmentSlot.MAINHAND }), new ResourceLocation("minecraft", "smite"), new BaneEnchant(Enchantment.Rarity.COMMON, MobType.f_21640_, new EquipmentSlot[] { EquipmentSlot.MAINHAND }), new ResourceLocation("minecraft", "sharpness"), new BaneEnchant(Enchantment.Rarity.UNCOMMON, MobType.f_21643_, new EquipmentSlot[] { EquipmentSlot.MAINHAND }), "bane_of_illagers", new DefenseEnchant(Enchantment.Rarity.COMMON, ProtectionEnchantment.Type.ALL, ARMOR), new ResourceLocation("minecraft", "protection"), 
          new DefenseEnchant(Enchantment.Rarity.UNCOMMON, ProtectionEnchantment.Type.FIRE, ARMOR), new ResourceLocation("minecraft", "fire_protection"), new DefenseEnchant(Enchantment.Rarity.RARE, ProtectionEnchantment.Type.EXPLOSION, ARMOR), new ResourceLocation("minecraft", "blast_protection"), new DefenseEnchant(Enchantment.Rarity.UNCOMMON, ProtectionEnchantment.Type.PROJECTILE, ARMOR), new ResourceLocation("minecraft", "projectile_protection"), new DefenseEnchant(Enchantment.Rarity.UNCOMMON, ProtectionEnchantment.Type.FALL, new EquipmentSlot[] { EquipmentSlot.FEET }), new ResourceLocation("minecraft", "feather_falling") });
  }
  
  public static EnchantmentInfo getEnchInfo(Enchantment ench) {
    if (!Apotheosis.enableEnch)
      return ENCHANTMENT_INFO.computeIfAbsent(ench, EnchantmentInfo::new); 
    EnchantmentInfo info = ENCHANTMENT_INFO.get(ench);
    if (enchInfoConfig == null)
      return new EnchantmentInfo(ench); 
    if (info == null) {
      info = EnchantmentInfo.load(ench, enchInfoConfig);
      ENCHANTMENT_INFO.put(ench, info);
      if (enchInfoConfig.hasChanged())
        enchInfoConfig.save(); 
      LOGGER.error("Had to late load enchantment info for {}, this is a bug in the mod {} as they are registering late!", ForgeRegistries.ENCHANTMENTS.getKey(ench), ForgeRegistries.ENCHANTMENTS.getKey(ench).m_135827_());
    } 
    return info;
  }
  
  public static int getDefaultMax(Enchantment ench) {
    int level = ench.m_6586_();
    if (level == 1)
      return 1; 
    EnchantmentInfo.PowerFunc minFunc = EnchantmentInfo.defaultMin(ench);
    int max = (int)(EnchantingStatRegistry.getAbsoluteMaxEterna() * 4.0F);
    int minPower = minFunc.getPower(level);
    if (minPower >= max)
      return level; 
    int lastPower = minPower;
    while (minPower < max) {
      minPower = minFunc.getPower(++level);
      if (lastPower == minPower)
        return level; 
      if (minPower > max)
        return level - 1; 
      lastPower = minPower;
    } 
    return level;
  }
  
  @SafeVarargs
  public static void fill(ResourceKey<CreativeModeTab> tab, Supplier<? extends Enchantment>... enchants) {
    Arrays.<Supplier<? extends Enchantment>>stream(enchants).map(dev.shadowsoffire.apotheosis.ench.EnchModule::enchFiller).forEach(filler -> TabFillingRegistry.register(filler, new ResourceKey[] { tab }));
  }
  
  public static ITabFiller enchFiller(Supplier<? extends Enchantment> e) {
    return (tab, output) -> {
        Enchantment ench = e.get();
        int maxLevel = EnchHooks.getMaxLevel(ench);
        output.m_246267_(EnchantedBookItem.m_41161_(new EnchantmentInstance(ench, maxLevel)), CreativeModeTab.TabVisibility.PARENT_TAB_ONLY);
        for (int level = 1; level <= maxLevel; level++)
          output.m_246267_(EnchantedBookItem.m_41161_(new EnchantmentInstance(ench, level)), CreativeModeTab.TabVisibility.SEARCH_TAB_ONLY); 
      };
  }
  
  public void reload(Apotheosis.ApotheosisReloadEvent e) {
    enchInfoConfig = new Configuration(new File(Apotheosis.configDir, "enchantments.cfg"));
    enchInfoConfig.setTitle("Apotheosis Enchantment Information");
    enchInfoConfig.setComment("This file contains configurable data for each enchantment.\nThe names of each category correspond to the registry names of every loaded enchantment.");
    ENCHANTMENT_INFO.clear();
    for (Enchantment ench : ForgeRegistries.ENCHANTMENTS)
      ENCHANTMENT_INFO.put(ench, EnchantmentInfo.load(ench, enchInfoConfig)); 
    for (Enchantment ench : ForgeRegistries.ENCHANTMENTS) {
      EnchantmentInfo info = ENCHANTMENT_INFO.get(ench);
      for (int i = 1; i <= info.getMaxLevel(); i++) {
        if (info.getMinPower(i) > info.getMaxPower(i))
          LOGGER.warn("Enchantment {} has min/max power {}/{} at level {}, making this level unobtainable.", ForgeRegistries.ENCHANTMENTS.getKey(ench), Integer.valueOf(info.getMinPower(i)), Integer.valueOf(info.getMaxPower(i)), Integer.valueOf(i)); 
      } 
    } 
    if (e == null && enchInfoConfig.hasChanged())
      enchInfoConfig.save(); 
    EnchConfig.load(new Configuration(new File(Apotheosis.configDir, "ench.cfg")));
  }
}
